#ifndef MorsePWM_h
#define MorsePWM_h

/*  Copyright (c) 2020 Jaroslaw Weglinski based on Lewis library 
    https://git.defproc.co.uk/DefProc/Lewis
    Changes licensed under the MIT license.*/

#include <Lewis.h>

//encode only version with second output for buzzer and option for modifying WPM ratio during runtime
class MorsePWM: public Lewis {
  protected:
    uint8_t fillRatio = 255;
    unsigned int _audio_freq = 100;
    uint8_t _audio_pin = 255;

  public:
    void begin(uint8_t rx_pin, uint8_t tx_pin, uint8_t words_per_minute, uint8_t use_interrupts, uint8_t audio_pin, unsigned int audio_freq);

    //for backward compatibility
    void begin(uint8_t rx_pin, uint8_t tx_pin, uint8_t words_per_minute, uint8_t use_interrupts);

    size_t write(uint8_t c);
    uint8_t setWPM(uint8_t words_per_minute);
    uint8_t getWPM(void);
    void dot();
    void dash();
    void timerISR();
};

#endif
